# report\_run\_with\_results

<pre class="language-python"><code class="lang-python">dbnl.report_run_with_results(
    project: <a data-footnote-ref href="#user-content-fn-1">Project</a>,
    column_data: pd.DataFrame,
    scalar_data: Optional[Union[dict[str, Any], pd.DataFrame]] = None
    display_name: Optional[str] = None,
    row_id: Optional[list[str]] = None,
    run_config_id: Optional[str] = None,
    metadata: Optional[dict[str, str]] = None,
) -> Run:
</code></pre>

## Parameters

| Arguments       | Description                                                                                                                                                                                                                                                                                                                     |
| --------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `project`       | The dbnl [Project](https://docs.dbnl.com/v0.20.x/using-distributional/python-sdk/sdk-objects/project) that this Run will be associated with.                                                                                                                                                                                    |
| `column_data`   | A [pandas DataFrame](https://pandas.pydata.org/docs/reference/api/pandas.DataFrame.html) with all the column results to report to dbnl. If `run_config_id` is provided, the columns of the DataFrame must match the `columns` described in the [RunConfig](https://pandas.pydata.org/docs/reference/api/pandas.DataFrame.html). |
| `scalar_data`   | A dict or pandas DataFrame with all the scalar results to report to dbnl.  If `run_config_id` is provided, the key of the dict must match the `scalars` described in the [RunConfig](https://pandas.pydata.org/docs/reference/api/pandas.DataFrame.html).                                                                       |
| `display_name`  | An optional display name for the Run. Display names do not have to be unique.                                                                                                                                                                                                                                                   |
| `row_id`        | An optional list of the column names that can be used as unique identifiers.                                                                                                                                                                                                                                                    |
| `run_config_id` | ID of the RunConfig to use for the Run, defaults to None. If provided, the RunConfig is used as is and the results are validated against it. If not provided, a new Run Config is inferred from the `column_data`.                                                                                                              |
| `metadata`      | Any additional key-value pairs information the user wants to track.                                                                                                                                                                                                                                                             |

## Returns

| Type                                                                                 | Description                            |
| ------------------------------------------------------------------------------------ | -------------------------------------- |
| [Run](https://docs.dbnl.com/v0.20.x/using-distributional/python-sdk/sdk-objects/run) | The closed Run with the uploaded data. |

## Examples

```python
import dbnl
import pandas as pd
dbnl.login()


proj = dbnl.get_or_create_project(name="test_p1")
test_data = pd.DataFrame({"error": [0.11, 0.33, 0.52, 0.24]})

run = dbnl.report_run_with_results(
    project=proj,
    column_data=test_data,
    row_id=["idx"],
)
```

[^1]: [Project](https://docs.dbnl.com/v0.20.x/using-distributional/python-sdk/sdk-objects/project)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.dbnl.com/v0.20.x/using-distributional/python-sdk/sdk-functions/run/report_run_with_results.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
